/* hemicube.h */
/* written by Jason R. Wilson    2/21/93 */

#import "datastruct.h"

/*----------------------------------------------------------------------*/

/* this type provides the information needed at each hemipixel */
typedef struct hemipixel 
{
   double depth; /* the depth of the polygon that projected there */
   double deltaFF; /* the delta form-factor for the pixel (precomputed) */
   int ID; /* the ID of the patch that projects to this pixel */
}
HemiPixel;

/*----------------------------------------------------------------------*/

void HemiRenderObjects
   (ObjectCell* ObjectHead,int Case,int winWidth,int winHeight,
    Window ViewWindow);
/* project polys onto viewwindow hemi-style */

void ComputeDeltas ();
/* computes the delta form-factors */

void InitHemiCube ();
/* init. the z-buffer and the ID of the hemi-cube */

void ProjectPatch (PolygonCell *Poly,double *Row);
/* find Row of form-factors for poly */
