/* render.h */
/* written by : Jason R. Wilson   2/23/93 */

/* provides routines for rasterization, hidden surface removal,
    and smooth linear interpolated shading */

#import "datastruct.h"

/*----------------------------------------------------------------------*/

typedef struct edgelistcell
/* assume convex polygons */
{
   int Xpos1, Xpos2; /* assume Xpos1 <= Xpos2 */
   double RIntensity1,RIntensity2;
   double GIntensity1,GIntensity2;
   double BIntensity1,BIntensity2;
   double Depth1,Depth2;
   double uValue1,uValue2;
   double vValue1,vValue2;
   double nValue1,nValue2;
   Boolean OneHere;
}
EdgeListCell;
/*----------------------------------------------------------------------*/



void RasterizeEdge (EdgeListCell *EdgeList,VisVertexCell *a,
		    VisVertexCell *b,int winWidth,int winHeight,
                    Window ViewWindow);
		    
/* This routine Rasterizes an Edge and adds the information to the edge */
/* list. */



void RenderObject (ObjectCell* Object,double **Zbuffer,Color **ScreenMap,
                   Window ViewWindow,double *MaxIntensity,
		   int winWidth,int winHeight,
		   Vector uvector, Vector vvector, Vector nvector, Point rpoint);
		   
/* This function renders the object using Zbuffer hidden surface removal */
/* and linear interpolation */

